import { aw as g, X as u, Y as t, a3 as b, cf as p, a5 as w, Z as h, hM as y, hN as f, a4 as m, O as c, w as C, ed as P, U as x, a8 as v, F as o, _ as k, a9 as i, G as V, aa as a, ab as l, bK as S, ac as $, af as n, hO as E } from "./e5ee6382.js";
import "react";
import { FormDataPropertyView as O } from "./2d01d58e.js";
import { textInputChildren as j } from "./6d384d56.js";
import { presets as A } from "./1dc93eb5.js";
import "react-dom";
function F(e) {
  return g`
    border-radius: ${e.radius};
    &:not(.ant-input-disabled, .ant-input-affix-wrapper-disabled),
    input {
      background-color: ${e.background};
      color:${e.text};
      font-weight:${e.textWeight};
      font-family:${e.fontFamily};
      border-color: ${e.border};
      &:focus,
      &.ant-input-affix-wrapper-focused {
        border-color: ${e.accent};
      }
      &:hover {
        border-color: ${e.accent};
      }
      .ant-input-clear-icon svg:hover {
        opacity: 0.65;
      }
    }
  `;
}
const H = u(E)`
  width: 100%;
  display: flex;
  justify-content: flex-start;
  ${(e) => e.$style && F(e.$style)}
`, N = [{
  label: t("colorPicker.click"),
  value: "click"
}, {
  label: t("colorPicker.hover"),
  value: "hover"
}], U = b([p]), D = {
  ...j,
  value: w("value", "#3377ff"),
  style: h(y, "style"),
  color: f("color", {}),
  trigger: m(N, "click"),
  disabledAlpha: c,
  showPresets: c,
  onEvent: U,
  presets: C(P, JSON.stringify(A, null, 2))
}, G = new x(D, (e, d) => {
  var s;
  return v(e, d), e.label({
    children: /* @__PURE__ */ o(H, {
      $style: e.style,
      value: (s = e == null ? void 0 : e.value) == null ? void 0 : s.value,
      disabledAlpha: e.disabledAlpha,
      showText: (r) => r.toHexString().toUpperCase(),
      allowClear: !0,
      trigger: e.trigger,
      disabled: e.disabled,
      onChange: (r) => {
        e.value.onChange(r.toHexString().toUpperCase()), e.color.onChange({
          hex: r.toHexString().toUpperCase(),
          hsb: r.toHsb(),
          rgb: r.toRgb()
        }), e.onEvent("change");
      },
      presets: e.showPresets && !k.isEmpty(e.presets) ? [e.presets] : []
    }),
    style: e.style
  });
}).setPropertyViewFn((e) => /* @__PURE__ */ i(V, {
  children: [/* @__PURE__ */ o(a, {
    name: l.basic,
    children: e.value.propertyView({
      label: t("prop.defaultValue")
    })
  }), /* @__PURE__ */ o(O, {
    ...e
  }), e.label.getPropertyView(), /* @__PURE__ */ i(a, {
    name: l.interaction,
    children: [e.onEvent.getPropertyView(), S(e)]
  }), /* @__PURE__ */ i(a, {
    name: l.advanced,
    children: [e.trigger.propertyView({
      label: t("colorPicker.trigger"),
      radioButton: !0
    }), e.disabledAlpha.propertyView({
      label: t("colorPicker.disabledAlpha")
    }), e.showPresets.propertyView({
      label: t("colorPicker.showPresets")
    }), e.showPresets.getView() && e.presets.propertyView({
      label: t("colorPicker.recommended")
    })]
  }), /* @__PURE__ */ o(a, {
    name: l.layout,
    children: $(e)
  }), /* @__PURE__ */ o(a, {
    name: l.style,
    children: e.style.getPropertyView()
  })]
})).setExposeStateConfigs([new n("value", t("export.inputValueDesc")), new n("color", t("export.inputValueDesc")), new n("disabled", t("prop.disabled"))]).build();
export {
  G as ColorPickerComp,
  U as colorPickerEvent,
  F as getStyle
};
