import { newCustomColumn as T } from "./3c642d02.js";
import { X as w, fF as E, aw as z, fG as B, Y as t, a9 as d, G as b, F as l, aa as a, bP as R, fH as L, ab as x, ac as M, bL as O, fI as D, fJ as F, fK as G, bQ as v, fL as $, fM as W, dp as N, fN as j, fO as Q, fP as J, fQ as X, fR as Y, eB as q, fS as U, e3 as H, cA as k, fT as Z } from "./e5ee6382.js";
import { useState as S, useMemo as _ } from "react";
import { getSelectedRowKeys as K } from "./181b705b.js";
import { ColumnTypeCompMap as ee } from "./3f1967d1.js";
import "./6b33f721.js";
import "./90d2a8a5.js";
import "./8905314b.js";
import "./5173bdcb.js";
import "./64524055.js";
import "react-dom";
import "./56dcc053.js";
import "./9ad67eae.js";
import "./27ed5e0c.js";
import "./0407a768.js";
import "./96668bca.js";
import "./2d01d58e.js";
import "./cffc75fd.js";
import "./6d384d56.js";
import "./40dd6bc2.js";
import "./b92ba042.js";
import "./cf07ad8d.js";
import "./64c1e83b.js";
import "./b73e9e0a.js";
import "./43f1a4db.js";
import "./7e73fb74.js";
import "./c6d26ac6.js";
import "./a6b350eb.js";
import "./1682fddc.js";
import "./5b7d51dc.js";
import "./9a55e072.js";
import "./e6fbb0dd.js";
import "./a8e0fc70.js";
import "./9c3afae6.js";
import "./78c0334b.js";
import "./d5e2bfa8.js";
import "./39788795.js";
import "./b3ce40b9.js";
import "./6a45a447.js";
const te = w.div`
  display: flex;
  justify-content: end;
  width: 100%;
  gap: 8px;
  align-items: center;
`, ie = w.span`
  ${E};
  color: #8b8fa3;
`, le = w(D)`
  width: 16px;
  height: 16px;
  cursor: pointer;

  &:hover {
    g g {
      stroke: #4965f2;
    }
  }
`, A = z`
  height: 16px;
  width: 16px;
  display: inline-block;

  &:hover {
    cursor: pointer;
  }

  &:hover path {
    fill: #315efb;
  }
`, re = w(F)`
  ${A}
`, oe = w(G)`
  ${A}
`, ne = w(v)`
  width: 100px;

  &,
  > div {
    height: 22px;
  }

  .ant-segmented-item-label {
    height: 18px;
    min-height: 18px;
    line-height: 18px;
    padding: 0;
  }
`, ae = w.div`
  display: flex;
  align-items: center;
  color: ${B}
  line-height: 16px;
  font-size: 13px;
`, de = [{
  label: t("table.allColumn"),
  value: "all"
}, {
  label: t("table.visibleColumn"),
  value: "visible"
}], ce = [{
  label: t("prop.hide"),
  value: "hide"
}, {
  label: t("table.editable"),
  value: "editable"
}, {
  label: t("table.autoWidth"),
  value: "autoWidth"
}, {
  label: t("table.sortable"),
  value: "sortable"
}, {
  label: t("table.align"),
  value: "align"
}];
function se(e) {
  const {
    hide: i,
    setHide: s
  } = e;
  return /* @__PURE__ */ l(i ? re : oe, {
    onClick: (o) => {
      s(!i);
    }
  });
}
function C(e, i) {
  const s = (o) => e === "autoWidth" ? o.children.autoWidth.getView() === "auto" : o.children[e].getView(), h = i ?? ((o) => o);
  return (o) => {
    const p = Array.isArray(o), y = p ? o : [o], f = y.map((c) => {
      if (e !== "editable")
        return !1;
      const m = c.children.render.getOriginalComp().children.comp.children.compType.getView();
      return !ee[m].canBeEditable();
    });
    let u = !0, g = !0;
    y.forEach((c, m) => {
      if (f[m]) {
        p || (u = !1);
        return;
      }
      s(c) ? g = !1 : u = !1;
    });
    const V = (c) => {
      y.forEach((m, r) => !f[r] && m.children[e].dispatch(H(k(h(c), !0))));
    };
    return e === "hide" ? /* @__PURE__ */ l(se, {
      hide: u,
      setHide: (c) => V(c)
    }) : /* @__PURE__ */ l(Z, {
      indeterminate: !u && !g,
      disabled: !p && f[0],
      checked: u,
      onChange: (c) => {
        V(c.target.checked);
      }
    });
  };
}
const P = {
  hide: C("hide"),
  editable: C("editable"),
  sortable: C("sortable"),
  autoWidth: C("autoWidth", (e) => e ? "auto" : "fixed"),
  align: (e) => {
    const i = Array.isArray(e) ? e : [e], s = Array.isArray(e) ? void 0 : e.children.align.getView();
    return /* @__PURE__ */ l(ne, {
      options: U,
      value: s,
      radioButton: !0,
      onChange: (h) => {
        i.forEach((o) => o.children.align.dispatch(H(k(h, !0))));
      }
    });
  }
};
function he(e) {
  const {
    comp: i
  } = e, s = K(i.children.selection)[0] ?? "0", [h, o] = S("all"), p = i.children.columns.getView(), y = i.children.dataRowExample.getView(), f = i.children.dynamicColumn.getView(), u = i.children.data.getView(), [g, V] = S("hide"), c = _(() => p.filter((r) => h === "all" || !r.children.hide.getView()), [h, p]), m = /* @__PURE__ */ d(te, {
    children: [/* @__PURE__ */ d("div", {
      style: {
        display: "flex",
        alignItems: "center",
        marginRight: "auto"
      },
      children: [/* @__PURE__ */ l($, {
        label: e.columnLabel
      }), /* @__PURE__ */ l(ie, {
        children: " (" + p.length + ")"
      })]
    }), y && /* @__PURE__ */ l(W, {
      title: t("table.refreshButtonTooltip"),
      children: /* @__PURE__ */ l(le, {
        onClick: () => {
          i.dispatch(N("columns", i.children.columns.dataChangedAction({
            rowExample: y,
            doGeneColumn: !0,
            dynamicColumn: f,
            data: u
          })));
        }
      })
    }), /* @__PURE__ */ l(j, {
      icon: /* @__PURE__ */ l(Q, {}),
      text: t("addItem"),
      onClick: () => {
        i.children.columns.dispatch(i.children.columns.pushAction(T()));
      }
    })]
  });
  return /* @__PURE__ */ l(b, {
    children: /* @__PURE__ */ l(J, {
      headerItem: /* @__PURE__ */ l(X, {
        title: /* @__PURE__ */ l(v, {
          border: !0,
          style: {
            width: "auto",
            marginLeft: "8px"
          },
          value: h,
          options: de,
          label: "",
          onChange: (r) => {
            o(r);
          }
        }),
        config: {
          dataIndex: "header"
        },
        draggable: !1,
        optionExtra: /* @__PURE__ */ d(ae, {
          children: [/* @__PURE__ */ l(v, {
            border: !0,
            style: {
              width: "auto"
            },
            value: g,
            options: ce,
            label: "",
            onChange: (r) => {
              V(r);
            }
          }), P[g](p)]
        })
      }),
      itemExtra: (r) => /* @__PURE__ */ l("div", {
        style: {
          display: "flex",
          alignItems: "center",
          height: "100%"
        },
        onClick: (n) => n.stopPropagation(),
        children: P[g](r)
      }),
      items: c,
      optionToolbar: m,
      itemTitle: (r) => {
        const n = r.getView();
        return n.hide ? /* @__PURE__ */ l("span", {
          style: {
            color: B
          },
          children: n.title
        }) : n.title;
      },
      popoverTitle: (r) => {
        const n = r.getView();
        return n.isCustom ? t("table.customColumn") : n.dataIndex;
      },
      content: (r, n) => /* @__PURE__ */ d(b, {
        children: [r.propertyView(s), r.getView().isCustom && /* @__PURE__ */ l(Y, {
          onClick: () => {
            q.confirm({
              title: t("table.deleteColumn"),
              content: t("table.confirmDeleteColumn") + `${r.getView().title}?`,
              onConfirm: () => i.children.columns.dispatch(i.children.columns.deleteAction(n)),
              confirmBtnType: "delete",
              okText: t("delete")
            });
          },
          children: t("delete")
        })]
      }),
      onAdd: () => {
        i.children.columns.dispatch(i.children.columns.pushAction(T()));
      },
      onMove: (r, n) => {
        const I = i.children.columns.arrayMoveAction(r, n);
        i.children.columns.dispatch(I);
      },
      dataIndex: (r) => r.getView().dataIndex,
      scrollable: !0
    })
  });
}
function pe(e) {
  const i = t("table.columnNum");
  return [
    R({
      filterText: i
    }, /* @__PURE__ */ l(he, {
      comp: e,
      columnLabel: i
    }))
    /* comp.children.dynamicColumn.propertyView({ label: trans("table.dynamicColumn") }),
    dynamicColumn &&
      comp.children.dynamicColumnConfig.propertyView({
        label: trans("table.dynamicColumnConfig"),
        tooltip: trans("table.dynamicColumnConfigDesc"),
      }), */
  ];
}
function _e(e) {
  const i = e.editorModeStatus, s = t("data");
  return /* @__PURE__ */ d(b, {
    children: [["logic", "both"].includes(i) && /* @__PURE__ */ l(a, {
      name: t("table.dataDesc"),
      children: R({
        filterText: s
      }, /* @__PURE__ */ l("div", {
        className: L,
        children: e.children.data.propertyView({
          label: s
        })
      }))
    }), ["layout", "both"].includes(i) && /* @__PURE__ */ l(a, {
      name: t("prop.columns"),
      children: pe(e)
    }), ["logic", "both"].includes(i) && /* @__PURE__ */ d(b, {
      children: [/* @__PURE__ */ d(a, {
        name: x.interaction,
        children: [e.children.onEvent.getPropertyView(), e.children.selection.getPropertyView(), M(e.children), O(e.children)]
      }), /* @__PURE__ */ l(a, {
        name: t("prop.toolbar"),
        children: e.children.toolbar.getPropertyView()
      })]
    }), ["layout", "both"].includes(i) && /* @__PURE__ */ d(b, {
      children: [/* @__PURE__ */ d(a, {
        name: x.layout,
        children: [e.children.size.propertyView({
          label: t("table.tableSize"),
          radioButton: !0
        }), e.children.autoHeight.getPropertyView(), e.children.showHorizontalScrollbar.propertyView({
          label: t("prop.showHorizontalScrollbar")
        }), !e.children.autoHeight.getView() && e.children.showVerticalScrollbar.propertyView({
          label: t("prop.showVerticalScrollbar")
        }), e.children.fixedHeader.propertyView({
          label: t("table.fixedHeader"),
          tooltip: t("table.fixedHeaderTooltip")
        }), e.children.hideHeader.propertyView({
          label: t("table.hideHeader")
        }), e.children.viewModeResizable.propertyView({
          label: t("table.viewModeResizable"),
          tooltip: t("table.viewModeResizableTooltip")
        }), e.children.visibleResizables.propertyView({
          label: t("table.visibleResizables"),
          tooltip: t("table.visibleResizablesTooltip")
        })]
      }), /* @__PURE__ */ l(a, {
        name: t("prop.pagination"),
        children: e.children.pagination.getPropertyView()
      })]
    }), ["logic", "both"].includes(i) && /* @__PURE__ */ l(b, {
      children: /* @__PURE__ */ d(a, {
        name: x.advanced,
        children: [e.children.expansion.getPropertyView(), e.children.showDataLoadSpinner.propertyView({
          label: t("table.showDataLoadSpinner")
        }), e.children.dynamicColumn.propertyView({
          label: t("table.dynamicColumn")
        }), e.children.dynamicColumn.getView() && e.children.dynamicColumnConfig.propertyView({
          label: t("table.dynamicColumnConfig"),
          tooltip: t("table.dynamicColumnConfigDesc")
        }), e.children.searchText.propertyView({
          label: t("table.searchText"),
          tooltip: t("table.searchTextTooltip"),
          placeholder: "{{input1.value}}"
        })]
      })
    }), ["layout", "both"].includes(i) && /* @__PURE__ */ d(b, {
      children: [/* @__PURE__ */ l(a, {
        name: "Table Style",
        children: e.children.style.getPropertyView()
      }), /* @__PURE__ */ l(a, {
        name: "Header Style",
        children: e.children.headerStyle.getPropertyView()
      }), /* @__PURE__ */ l(a, {
        name: "Toolbar Style",
        children: e.children.toolbarStyle.getPropertyView()
      }), /* @__PURE__ */ d(a, {
        name: "Row Style",
        children: [e.children.showRowGridBorder.propertyView({
          label: t("table.showVerticalRowGridBorder")
        }), e.children.showHRowGridBorder.propertyView({
          label: t("table.showHorizontalRowGridBorder")
        }), e.children.rowStyle.getPropertyView(), e.children.rowAutoHeight.getPropertyView(), e.children.rowHeight.getPropertyView(), e.children.rowColor.getPropertyView()]
      }), /* @__PURE__ */ l(a, {
        name: "Column Style",
        children: e.children.columnsStyle.getPropertyView()
      })]
    })]
  });
}
export {
  _e as compTablePropertyView
};
