import { X as m, ai as E, fy as X, dT as _, _ as x, F as i, fz as q, dk as J, e4 as K, a8 as Q, dl as Y, a9 as Z, dm as tt, aC as et, fA as it, fB as nt, dn as ot, e3 as at, dt as rt, du as st } from "./e5ee6382.js";
import { createContext as lt, useRef as dt, useContext as V, useMemo as o } from "react";
import { ContextContainerComp as ct } from "./5ce97148.js";
import "react-dom";
const ht = m.div`
  height: 100%;
  border: 1px solid ${(e) => e.$style.border};
  border-radius: ${(e) => e.$style.radius};
  padding: 3px ${(e) => e.$paddingWidth};
  rotate: ${(e) => e.$style.rotation};
  background-color: ${(e) => e.$style.background};
  ${(e) => e.$animationStyle}
`, gt = m.div`
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 3px;
`, mt = m.div`
  height: ${(e) => e.$autoHeight ? "100%" : "calc(100% - 32px)"};
`, pt = m.div` 
  height: 100%;
  display: flex;
  align-items: center;
  // justify-content: center;
`, ut = m.div`
  height: ${(e) => e.$autoHeight ? "auto" : "100%"};
  display: flex;
  flex-direction: ${(e) => e.$isHorizontal && !e.$isGrid ? "row" : "column"};
  height: 100%;
`, W = lt({
  horizontalWidth: "100%",
  minHorizontalWidth: "100px"
}), ft = (e) => {
  const {
    horizontalWidth: a,
    minHorizontalWidth: t
  } = V(W);
  return /* @__PURE__ */ i("div", {
    style: {
      width: a,
      minWidth: t || "0px"
    },
    children: /* @__PURE__ */ i(rt, {
      ...e,
      emptyRows: 15,
      containerPadding: [4, 4],
      hintPlaceholder: st
    })
  });
};
function xt({
  minHorizontalWidth: e,
  horizontalWidth: a,
  ...t
}) {
  const {
    itemIdx: d,
    offset: r,
    containerProps: c,
    autoHeight: y,
    scrollContainerRef: w,
    minHeight: p,
    horizontalGridCells: z
  } = t;
  return /* @__PURE__ */ i(W.Provider, {
    value: {
      horizontalWidth: a,
      minHorizontalWidth: e
    },
    children: /* @__PURE__ */ i(ft, {
      layout: c.layout,
      items: ot(c.items),
      horizontalGridCells: z,
      positionParams: c.positionParams,
      dispatch: d === r ? c.dispatch : x.noop,
      style: {
        height: "100%",
        // in case of horizontal mode, minHorizontalWidth is 0px
        width: e || "100%",
        backgroundColor: "transparent"
        // flex: "auto",
      },
      autoHeight: y,
      isDroppable: d === r,
      isDraggable: d === r,
      isResizable: d === r,
      isSelectable: d === r,
      scrollContainerRef: w,
      overflow: "hidden",
      minHeight: p,
      enableGridLines: !0
    })
  });
}
function $t(e) {
  const {
    comp: a
  } = e, t = a.children, d = dt(null), r = V(E), c = r.isDragging, [y, w] = X(0, c), p = o(() => t.dynamicHeight.getView(), [t.dynamicHeight]), z = o(() => t.heightUnitOfRow.getView(), [t.heightUnitOfRow]), P = o(() => t.container.getView(), [t.container]), v = o(() => t.itemIndexName.getView(), [t.itemIndexName]), R = o(() => t.itemDataName.getView(), [t.itemDataName]), {
    data: I,
    itemCount: $
  } = o(() => _(t.noOfRows.getView()), [t.noOfRows]), D = o(() => t.horizontalGridCells.getView(), [t.horizontalGridCells]), u = o(() => t.autoHeight.getView(), [t.autoHeight]), O = o(() => t.scrollbars.getView(), [t.scrollbars]), b = o(() => t.horizontal.getView(), [t.horizontal]), M = o(() => t.minHorizontalWidth.getView(), [t.minHorizontalWidth]), g = o(() => Math.max(1, t.noOfColumns.getView()), [t.noOfColumns]), s = o(() => {
    const l = t.pagination.getView(), h = l.total || $;
    let f = l.current, n = (f - 1) * l.pageSize;
    const H = Math.max(0, Math.min(l.pageSize, h - n));
    return {
      pagination: {
        ...l,
        current: f,
        total: h
      },
      offset: n,
      currentPageSize: H,
      total: h
    };
  }, [t.pagination, $]), S = t.style.getView(), G = t.animationStyle.getView(), L = a.realSimpleContainer().children.layout.getView(), C = s.currentPageSize > 0 && (x.isEmpty(L) || r.isDragging), k = C ? 1 : Math.floor((s.currentPageSize + g - 1) / g), N = C ? "100%" : p ? "auto" : z * 44 + "px", F = c && u ? y + "px" : "100%", j = x.range(0, k).map((l) => /* @__PURE__ */ i("div", {
    style: {
      height: N,
      width: "100%"
    },
    children: /* @__PURE__ */ i(pt, {
      children: x.range(0, g).map((f) => {
        const n = l * g + f + s.offset;
        if (n >= s.total || n >= s.offset + s.pagination.pageSize || C && n > s.offset)
          return /* @__PURE__ */ i("div", {
            style: {
              flex: "auto"
            }
          }, n);
        const H = P({
          [v]: n,
          [R]: q(I, n)
        }, String(n)).getView(), U = () => {
          a.children.container.dispatch(at(ct.batchDeleteAction([String(n)])));
        };
        return /* @__PURE__ */ i(xt, {
          itemIdx: n,
          offset: s.offset,
          containerProps: H,
          horizontalGridCells: D,
          autoHeight: c || p,
          scrollContainerRef: d,
          minHeight: F,
          unMountFn: U,
          horizontalWidth: `${100 / g}%`,
          minHorizontalWidth: b ? M : void 0
        }, n);
      })
    })
  }, l)), A = r.getAppSettings().maxWidth, B = J(A) ? "4px" : "16px", T = K(a.children);
  return Q(T, a.dispatch), /* @__PURE__ */ i(Y.Provider, {
    value: S.background,
    children: /* @__PURE__ */ Z(ht, {
      $style: S,
      $paddingWidth: B,
      $animationStyle: G,
      children: [/* @__PURE__ */ i(mt, {
        ref: d,
        $autoHeight: u,
        children: /* @__PURE__ */ i(tt, {
          style: {
            height: u ? "auto" : "100%",
            margin: "0px",
            padding: "0px"
          },
          hideScrollbar: !O,
          children: /* @__PURE__ */ i(et, {
            onResize: (l, h) => {
              h && w(h);
            },
            observerOptions: {
              box: "border-box"
            },
            render: () => /* @__PURE__ */ i(ut, {
              $isHorizontal: b,
              $isGrid: g > 1,
              $autoHeight: u,
              children: j
            })
          })
        })
      }), /* @__PURE__ */ i(gt, {
        children: /* @__PURE__ */ i(it, {
          size: "small",
          itemRender: nt,
          ...s.pagination
        })
      })]
    })
  });
}
export {
  $t as ListView
};
