import { newPrimaryColumn as q, ColumnComp as A } from "./3c642d02.js";
import { _ as F } from "./8905314b.js";
import { tableFilterOperatorMap as z } from "./6a45a447.js";
import { _ as c, gq as I, av as B, a9 as H, F as C, au as k, jd as U, je as X, hc as K, dY as w, jf as O, dX as S, fE as Y, jg as G } from "./e5ee6382.js";
import "react";
const f = "children", d = "__ob_origin_index", $ = "__ob_origin_record", x = 55, T = 500;
function J(a, t, e, n) {
  let o = a;
  return t && (o = o.filter((i) => {
    let s = t == null ? void 0 : t.toLowerCase();
    return s ? Object.values(i).find((l) => l == null ? void 0 : l.toString().toLowerCase().includes(s)) : !0;
  })), n && e.filters.length > 0 && (o = o.filter((i) => {
    for (let s of e.filters) {
      const l = i[s.columnKey], u = z[s.operator].filter(s.filterValue, l);
      if (e.stackType === "or" && u)
        return !0;
      if (e.stackType === "and" && !u)
        return !1;
    }
    return e.filters.length === 0 || e.stackType === "and" ? !0 : e.stackType !== "or";
  })), o;
}
function Q(a, t, e) {
  let n = a.map((o, i) => ({
    ...o,
    [d]: i + ""
  }));
  if (e.length > 0) {
    const [o, i] = c(e).filter((s) => {
      var l;
      return !!s.column && ((l = t[s.column]) == null ? void 0 : l.sortable);
    }).map((s) => [s.column, s.desc ? "desc" : "asc"]).unzip().value();
    n = c.orderBy(n, o.map((s) => (l) => {
      const u = l[s];
      return typeof u == "string" ? u.toLowerCase() : u;
    }), i);
  }
  return n;
}
function E({
  hide: a,
  tempHide: t,
  enableColumnSetting: e
}) {
  return e && t || a;
}
function R(a, t) {
  return a + "-" + t;
}
function L(a, t) {
  const e = t + "";
  return Array.isArray(a[f]) ? {
    ...a,
    [d]: e,
    children: a[f].map((n, o) => L(n, R(e, o + "")))
  } : {
    ...a,
    [d]: e
  };
}
function M(a, t, e) {
  return a.map((n, o) => {
    const i = {
      [d]: n[d]
    };
    return e.forEach((s) => {
      const l = s.render.wrap({
        currentCell: n[s.dataIndex],
        currentRow: c.omit(n, d),
        currentIndex: o % t,
        currentOriginalIndex: n[d]
      });
      Array.isArray(n[f]) && (i[f] = M(n[f], t, e));
      const u = l.comp[F](l.comp);
      u !== null && (i[s.dataIndex] = u);
    }), i;
  });
}
function W(a, t) {
  return a.map((e) => {
    const n = c(e).omit(d).mapKeys((o, i) => t[i] || i).value();
    return Array.isArray(e[f]) ? {
      ...n,
      [f]: W(e[f], t)
    } : n;
  });
}
function Z(a, t) {
  return c.mapValues(t, (e, n) => {
    const o = e.wrap().compType, i = {
      compType: o
    };
    return o === "tag" ? i.uniqueTags = c(a).map((s) => s[n]).filter((s) => !!s).uniq().value() : o === "badgeStatus" && (i.uniqueStatus = c(a).map((s) => {
      const l = s[n];
      return l.split(" ")[1] ? {
        status: l.slice(0, l.indexOf(" ")),
        text: l.slice(l.indexOf(" ") + 1)
      } : {
        status: l,
        text: ""
      };
    }).uniqBy("text").value()), i;
  });
}
function tt(a) {
  const {
    title: t,
    tooltip: e,
    editable: n
  } = a;
  return /* @__PURE__ */ H("div", {
    children: [/* @__PURE__ */ C(k, {
      title: e,
      children: /* @__PURE__ */ C("span", {
        style: {
          borderBottom: e ? "1px dotted" : ""
        },
        children: t
      })
    }), n && /* @__PURE__ */ C(U, {
      style: {
        verticalAlign: "baseline",
        marginLeft: "4px"
      }
    })]
  });
}
function et(a, t) {
  let e = [];
  return Object.keys(a).forEach((n) => {
    t.includes(n) || e.push({
      label: n,
      value: `{{currentRow.${n}}}`
    });
  }), e.push({
    label: "Select with handlebars",
    value: "{{currentCell}}"
  }), e;
}
function rt(a, t, e, n, o, i, s, l) {
  const u = a.filter((r) => r.isCustom).map((r) => r.dataIndex), h = et(s, u), g = new Map(t.map((r) => [r.column, r.desc ? "descend" : "ascend"]));
  return c.sortBy(a, (r) => {
    if (r.fixed === "left")
      return -1;
    if (r.fixed === "right")
      return Number.MAX_SAFE_INTEGER;
    if (i.length > 0) {
      const p = i.indexOf(r.isCustom ? r.title : r.dataIndex);
      if (p >= 0)
        return p;
    }
    return 0;
  }).flatMap((r) => {
    if (E({
      hide: r.hide,
      tempHide: r.tempHide,
      enableColumnSetting: e
    }))
      return [];
    if (o && i.length > 0 && !i.includes(r.isCustom ? r.title : r.dataIndex))
      return [];
    const p = (s[r.dataIndex] ?? {}).uniqueTags ?? [], P = (s[r.dataIndex] ?? {}).uniqueStatus ?? [], D = tt({
      title: r.title,
      tooltip: r.titleTooltip,
      editable: r.editable
    });
    return {
      title: r.showTitle ? D : "",
      titleText: r.title,
      dataIndex: r.dataIndex,
      align: r.align,
      width: r.autoWidth === "auto" ? 0 : r.width,
      fixed: r.fixed === "close" ? !1 : r.fixed,
      style: {
        background: r.background,
        margin: r.margin,
        text: r.text,
        border: r.border,
        radius: r.radius,
        textSize: r.textSize,
        textWeight: r.textWeight,
        fontStyle: r.fontStyle,
        fontFamily: r.fontFamily,
        borderWidth: r.borderWidth
      },
      linkStyle: {
        text: r.linkColor,
        hoverText: r.linkHoverColor,
        activeText: r.linkActiveColor
      },
      cellColorFn: r.cellColor,
      onWidthResize: r.onWidthResize,
      render: (b, m, _) => {
        const y = c.omit(m, d);
        return r.render({
          currentCell: b,
          currentRow: y,
          currentIndex: _,
          currentOriginalIndex: I(m[d]),
          initialColumns: h
        }, String(m[d])).getView().view({
          editable: r.editable,
          size: n,
          candidateTags: p,
          candidateStatus: P,
          textOverflow: r.textOverflow,
          cellTooltip: r.cellTooltip({
            currentCell: b,
            currentRow: y,
            currentIndex: _
          }),
          onTableEvent: l
        });
      },
      ...r.sortable ? {
        sorter: !0,
        sortOrder: g.get(r.dataIndex)
      } : {}
    };
  });
}
function v(a) {
  var t;
  return (t = a.column) != null && t.dataIndex ? {
    column: a.column.dataIndex.toString(),
    desc: a.order === "descend"
  } : null;
}
function nt(a, t, e, n, o, i) {
  if (n.action === "sort") {
    let s = [];
    if (Array.isArray(e))
      e.forEach((l) => {
        const u = v(l);
        u && s.push(u);
      });
    else {
      const l = v(e);
      l && s.push(l);
    }
    o(B("sort", s, !0)), i("sortChange");
  }
}
function j(a, t) {
  const e = (i) => {
    const s = new Blob([i]).size;
    return i.length === s ? i.length * 10 : i.length * 20;
  }, n = c.max(t.map((i) => {
    const s = i[a];
    return s ? e(s.toString()) : x;
  })) || 0, o = e(a);
  return Math.max(Math.min(T, Math.max(o, n) + 10), x);
}
function it(a, t) {
  const e = a.findIndex((o) => o[d] === t);
  if (e < 0)
    return;
  const n = a[e];
  return {
    currentRow: c.omit(n, d),
    currentIndex: e,
    currentOriginalIndex: I(n[d])
  };
}
function V(a) {
  const t = N(a);
  return t && Array.isArray(t[f]);
}
const ht = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  COLUMN_CHILDREN_KEY: f,
  COL_MAX_WIDTH: T,
  COL_MIN_WIDTH: x,
  OB_ROW_ORI_INDEX: d,
  OB_ROW_RECORD: $,
  buildOriginIndex: R,
  calcColumnWidth: j,
  columnHide: E,
  columnsToAntdFormat: rt,
  filterData: J,
  genSelectionParams: it,
  getColumnsAggr: Z,
  getOriDisplayData: M,
  onTableChange: nt,
  sortData: Q,
  supportChildrenTree: V,
  tranToTableRecord: L,
  transformDispalyData: W
}, Symbol.toStringTag, { value: "Module" })), st = Y(A);
function N(a) {
  if (a.length <= 0 || typeof a[0] == "string")
    return;
  const t = {};
  return a.slice(0, 50).forEach((e) => {
    Object.keys(e).forEach((n) => {
      t.hasOwnProperty(n) || (t[n] = e[n]);
    });
  }), t;
}
class at extends st {
  reduce(t) {
    if (X(t, "dataChanged")) {
      const e = t.value.rowExample, {
        readOnly: n
      } = G();
      let o = this;
      if (t.value.doGeneColumn && (t.value.dynamicColumn || !n)) {
        const i = this.geneColumnsAction(e, t.value.data);
        o = this.reduce(this.multiAction(i));
      }
      return o;
    }
    return super.reduce(t);
  }
  getChangeSet() {
    const t = {};
    return this.getView().forEach((n) => {
      const o = n.getChangeSet();
      Object.keys(o).forEach((i) => {
        Object.keys(o[i]).forEach((s) => {
          c.isNil(o[i][s]) || (t[s] || (t[s] = {}), t[s][i] = o[i][s]);
        });
      });
    }), t;
  }
  dispatchClearChangeSet() {
    this.getView().forEach((e) => e.dispatchClearChangeSet());
  }
  /**
   * If the table data changes, call this method to trigger the action
   */
  dataChangedAction(t) {
    return K({
      type: "dataChanged",
      ...t
    }, !0);
  }
  /**
   * According to the data, adjust the column
   */
  geneColumnsAction(t, e) {
    if (t == null)
      return [];
    const n = Object.keys(t);
    if (n.length === 0)
      return [];
    const o = this.getView(), i = [];
    let s = 0;
    return o.forEach((l, u) => {
      if (l.getView().isCustom)
        return;
      const h = l.getView().dataIndex;
      (h === f || !n.find((g) => h === g)) && (i.push(this.deleteAction(u - s)), s += 1);
    }), n.forEach((l) => {
      l === f && V(e) || o.find((u) => u.getView().dataIndex === l) || i.push(this.pushAction(q(l, j(l, e))));
    }), i.length === 0 ? [] : i;
  }
  withParamsNode() {
    const t = this.getView(), e = c(t).map((o) => o.children.render.getOriginalComp().node()).toPairs().fromPairs().value();
    return w(this, "withParamsNode", [S(e), e], (o, i) => O(o[1], i[1]))[0];
  }
  getColumnsNode(t) {
    const e = this.getView(), n = c(e).map((i) => i.children[t].node()).toPairs().fromPairs().value();
    return w(this, "col_nodes_" + t, [S(n), n], (i, s) => O(i[1], s[1]))[0];
  }
  setSelectionAction(t) {
    return this.forEachAction(A.setSelectionAction(t));
  }
}
const pt = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  ColumnListComp: at,
  tableDataRowExample: N
}, Symbol.toStringTag, { value: "Module" }));
export {
  f as C,
  d as O,
  L as a,
  M as b,
  j as c,
  Z as d,
  E as e,
  J as f,
  it as g,
  W as h,
  at as i,
  rt as j,
  V as k,
  x as l,
  ht as m,
  pt as n,
  nt as o,
  Q as s,
  N as t
};
