import { di as h, w as a, s as g, O as i, S as d, dd as V, aB as C, Z as n, g1 as S, dg as b, hH as f, g2 as m, g3 as P, v as T, bT as A, C as v, M as D, a8 as H, _ as c, x as R, z as U, g4 as y, dX as w, dY as x, Y as r } from "./e5ee6382.js";
import { ContainerBodyChildComp as E } from "./c58abcdd.js";
import "react";
import "react-dom";
const W = {
  header: h,
  sider: h,
  body: a(g(E), {
    0: {
      view: {
        layout: {},
        items: {}
      }
    }
  }),
  showApp: i,
  contentApp: d,
  baseUrl: d,
  footer: h,
  showHeader: i.DEFAULT_TRUE,
  showSider: i.DEFAULT_TRUE,
  innerSider: i.DEFAULT_TRUE,
  siderCollapsible: a(i, !1),
  siderCollapsed: a(i, !1),
  siderRight: a(i, !1),
  siderWidth: a(d, "20%"),
  siderCollapsedWidth: a(d, "0"),
  showFooter: i,
  horizontalGridCells: V,
  autoHeight: C,
  siderScrollbars: a(i, !1),
  contentScrollbars: a(i, !1),
  style: n(S, "style"),
  headerStyle: n(b, "headerStyle"),
  siderStyle: n(f, "siderStyle"),
  bodyStyle: n(m, "bodyStyle"),
  footerStyle: n(P, "footerStyle"),
  appliedThemeId: T("")
}, F = A(new D(W, (l, e) => (H(l, e), {
  ...l,
  dispatch: e
})).build(), v);
class N extends F {
  // scrollbars: any;
  allContainers() {
    return [this.children.header, this.children.sider, ...Object.values(this.children.body.getView()).map((e) => e.children.view), this.children.footer];
  }
  realSimpleContainer(e) {
    return c.isNil(e) ? this.children.body.getView()[0].children.view : this.allContainers().find((t) => t.realSimpleContainer(e));
  }
  getCompTree() {
    return R(this.allContainers().map((e) => e.getCompTree()));
  }
  findContainer(e) {
    for (const t of this.allContainers()) {
      const o = t.findContainer(e);
      if (o)
        return o === t ? this : o;
    }
  }
  getPasteValue(e) {
    return {
      ...this.toJsonValue(),
      header: this.children.header.getPasteValue(e),
      sider: this.children.sider.getPasteValue(e),
      body: c.mapValues(this.children.body.getView(), (t) => ({
        ...t.toJsonValue(),
        view: t.children.view.getPasteValue(e)
      })),
      footer: this.children.footer.getPasteValue(e)
    };
  }
  autoHeight() {
    return this.children.autoHeight.getView();
  }
  exposingNode() {
    const e = {};
    return U(this.getCompTree(), (t) => {
      const o = t.children.comp;
      let s = o.exposingNode();
      if (y(s) && !s.children.hasOwnProperty("formDataKey")) {
        const p = o.children.formDataKey;
        p && (s = w({
          ...s.children,
          formDataKey: p.exposingNode()
        }));
      }
      return e[t.children.name.getView()] = s, !0;
    }), x(this, "exposing_node", w(e), u);
  }
  getPropertyView() {
    return [this.areaPropertyView(), this.gridPropertyView(), this.heightPropertyView()];
  }
  areaPropertyView() {
    return [this.children.showHeader.propertyView({
      label: r("prop.showHeader")
    }), this.children.showSider.propertyView({
      label: r("prop.showSider")
    }), this.children.siderRight.propertyView({
      label: r("prop.siderRight")
    }), this.children.innerSider.propertyView({
      label: r("prop.innerSider")
    }), this.children.siderCollapsible.propertyView({
      label: r("prop.siderCollapsible")
    }), this.children.siderCollapsed.propertyView({
      label: r("prop.siderCollapsed")
    }), this.children.showFooter.propertyView({
      label: r("prop.showFooter")
    }), this.children.siderWidth.propertyView({
      label: r("prop.siderWidth"),
      tooltip: r("prop.siderWidthTooltip")
    }), this.children.siderCollapsedWidth.propertyView({
      label: r("prop.siderCollapsedWidth"),
      tooltip: r("prop.siderCollapsedWidthTooltip")
    })];
  }
  heightPropertyView() {
    return [this.children.autoHeight.getPropertyView(), this.children.siderScrollbars.propertyView({
      label: r("prop.siderScrollbar")
    }), !this.children.autoHeight.getView() && this.children.contentScrollbars.propertyView({
      label: r("prop.contentScrollbar")
    })];
  }
  gridPropertyView() {
    return [this.children.horizontalGridCells.propertyView({
      label: r("prop.horizontalGridCells")
    })];
  }
  appSelectorPropertyView() {
    return [this.children.showApp.propertyView({
      label: r("prop.showApp"),
      tooltip: r("prop.showAppTooltip")
    }), this.children.showApp.getView() && this.children.contentApp.propertyView({
      label: r("prop.appID")
    }), this.children.showApp.getView() && this.children.baseUrl.propertyView({
      label: r("prop.baseURL")
    })];
  }
  stylePropertyView() {
    return this.children.style.getPropertyView();
  }
  headerStylePropertyView() {
    return this.children.headerStyle.getPropertyView();
  }
  siderStylePropertyView() {
    return this.children.siderStyle.getPropertyView();
  }
  bodyStylePropertyView() {
    return this.children.bodyStyle.getPropertyView();
  }
  footerStylePropertyView() {
    return this.children.footerStyle.getPropertyView();
  }
}
function u(l, e) {
  if (l === e)
    return !0;
  if (l && e && y(l) && y(e)) {
    const t = l.children, o = e.children, s = Object.keys(t);
    return s.length === Object.keys(o).length && s.every((p) => u(t[p], o[p]));
  }
  return !1;
}
export {
  N as PageLayoutComp
};
