import { ColumnComp as g } from "./3c642d02.js";
import { J as a, dU as d, _ as c } from "./e5ee6382.js";
import { MockTableComp as w } from "./62630e54.js";
import { TableComp as x } from "./a8d34f75.js";
import { O as f } from "./b3ce40b9.js";
import "react";
import "./3f1967d1.js";
import "./56dcc053.js";
import "./8905314b.js";
import "./5173bdcb.js";
import "react-dom";
import "./90d2a8a5.js";
import "./64524055.js";
import "./9ad67eae.js";
import "./27ed5e0c.js";
import "./0407a768.js";
import "./96668bca.js";
import "./2d01d58e.js";
import "./cffc75fd.js";
import "./6d384d56.js";
import "./40dd6bc2.js";
import "./b92ba042.js";
import "./cf07ad8d.js";
import "./64c1e83b.js";
import "./b73e9e0a.js";
import "./43f1a4db.js";
import "./7e73fb74.js";
import "./c6d26ac6.js";
import "./a6b350eb.js";
import "./1682fddc.js";
import "./5b7d51dc.js";
import "./9a55e072.js";
import "./e6fbb0dd.js";
import "./a8e0fc70.js";
import "./9c3afae6.js";
import "./78c0334b.js";
import "./d5e2bfa8.js";
import "./39788795.js";
import "./6b33f721.js";
import "./cfe3bede.js";
import "./7227374a.js";
import "./6a45a447.js";
import "./6e9126c0.js";
import "./181b705b.js";
import "./aa633928.js";
import "./85436a4a.js";
import "./99b0f1e4.js";
test("test column", () => {
  const e = {
    title: "name"
    // editable: true, // TODO: change to boolean
  };
  let o = new g({
    value: e
  });
  o = a(o);
  const t = o.getView();
  expect(t.title).toEqual(e.title);
});
test("test column render", () => {
  const e = {
    render: {
      compType: "text",
      comp: {
        text: "{{currentRow.id}}"
      }
    }
    // editable: true, // TODO: change to boolean
  };
  let o = new g({
    value: e
  });
  o = a(o);
  const t = o.getView();
  expect(t.render({
    currentCell: null,
    currentIndex: null,
    currentRow: {
      id: "hello"
    },
    currentOriginalIndex: null
  }, "0").getView().view({}).props.normalView).toEqual("hello");
});
test("test table", async () => {
  const e = {
    data: JSON.stringify([{
      a: 1
    }]),
    columns: [{
      dataIndex: "a",
      hide: !0
    }, {
      title: "custom",
      dataIndex: "",
      isCustom: !0
    }]
  }, o = {
    query1: d({
      data: [{
        q: 1
      }]
    }),
    query2: d({
      data: [{
        q2: 2
      }]
    })
  };
  let t = new x({
    dispatch: (m) => {
      t = a(t.reduce(m), o);
    },
    value: e
  });
  t = a(t);
  let r = t.children.columns.getView();
  expect(r.length).toEqual(2), t = a(t.reduce(t.changeChildAction("data", '[{"a":1, "c":2, "d":3}]'))), await new Promise((m) => setTimeout(m, 20)), r = t.children.columns.getView(), expect(r.length).toEqual(4), expect(r[0].getView().dataIndex).toEqual("a"), expect(r[0].getView().hide).toBe(!0), expect(r[1].getView().title).toEqual("custom"), expect(r[2].getView().title).toEqual("c"), expect(r[3].getView().title).toEqual("d");
}, 1e3);
test("test mock table render", () => {
  let e = new w({});
  e = a(e);
});
test("test table data transform", () => {
  function e(i, l) {
    const p = l.exposingValues.displayData, {
      data: u
    } = l.getProps(), s = l.filterData;
    return expect(u.length).toEqual(3), expect(p.length).toEqual(i), expect(p.map((n) => c.omit(n, "custom"))).toEqual(c.map(s, (n) => c.omit(n, f))), {
      transformedData: s,
      data: u,
      displayData: p
    };
  }
  const o = {
    data: JSON.stringify([{
      id: 1,
      name: "gg"
    }, {
      id: 5,
      name: "gg2"
    }, {
      id: 3,
      name: "jjj"
    }]),
    columns: [{
      dataIndex: "id",
      isCustom: !1,
      sortable: !0,
      render: {
        compType: "text",
        comp: {
          text: "{{currentCell}}"
        }
      }
    }, {
      dataIndex: "name",
      isCustom: !1,
      render: {
        compType: "text",
        comp: {
          text: "{{currentCell}}"
        }
      }
    }, {
      title: "custom",
      dataIndex: "ealekfg",
      isCustom: !0,
      render: {
        compType: "image",
        comp: {
          src: "{{currentRow.id}}"
        }
      }
    }]
  };
  let t = new x({
    dispatch: (i) => {
      t = a(t.reduce(i));
    },
    value: o
  });
  t = a(t), t = a(t.reduce(t.changeChildAction("sort", [{
    column: "id",
    desc: !0
  }])));
  let {
    transformedData: r,
    data: m,
    displayData: h
  } = e(3, t);
  expect(r.map((i) => i.id)).toEqual([5, 3, 1]), t = a(t.reduce(t.changeChildAction("toolbar", {
    searchText: "gg"
  }))), e(2, t), t = a(t.reduce(t.changeChildAction("toolbar", {
    showFilter: !0,
    filter: {
      stackType: "and",
      filters: [{
        columnKey: "id",
        filterValue: "4",
        operator: "gt"
      }, {
        columnKey: "id",
        filterValue: "5",
        operator: "lte"
      }]
    }
  }))), e(1, t);
});
